// sample.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "sample.h"
#include "sampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CsampleApp

BEGIN_MESSAGE_MAP(CsampleApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CsampleApp construction

CsampleApp::CsampleApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CsampleApp object

CsampleApp theApp;
HANDLE hSingleInstanceMutex = NULL;
DWORD dwCreateMutexErr;

// CsampleApp initialization
BOOL CsampleApp::InitInstance()
{
	::SetCursor(LoadStandardCursor(IDC_APPSTARTING));
	CoInitialize(NULL);

	hSingleInstanceMutex = ::CreateMutex(NULL, FALSE, L"FE49C45724BB46ffA9AF0C5D110F3CD6");
	dwCreateMutexErr = GetLastError();

	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	//SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	if ((hSingleInstanceMutex != NULL) && (dwCreateMutexErr != ERROR_ALREADY_EXISTS))
	{
		CsampleDlg dlg;
		m_pMainWnd = &dlg;
		INT_PTR nResponse = dlg.DoModal();
		if (nResponse == IDOK)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with OK
		}
		else if (nResponse == IDCANCEL)
		{
			// TODO: Place code here to handle when the dialog is
			//  dismissed with Cancel
		}
	}
	else
	{
		::SetCursor(LoadStandardCursor(IDC_ARROW));
	}

	::ReleaseMutex(hSingleInstanceMutex);

	// terminate process if for some reason are not finished/cancelled HID read operations and the process remains active
	TerminateProcess(GetCurrentProcess(), 0);

	// Since the dialog has been closed, return FALSE so that we exit the
	// application, rather than start the application's message pump.
	return FALSE;
}

int CsampleApp::ExitInstance()
{
	CoUninitialize();
	return CWinApp::ExitInstance();
}
